; int sub_asm(int* vector1, int width, int i, int j)
; Esta funcion resta 128b: [vector1 + i * width + j] = [vector1 + i * width + j] - [vector2]  
; el out corresponde al valor de edx despues de la multiplicacion, el mismo debe ser 0

BITS 32

%define i_matrix [ebp + 8]
%define width [ebp + 12]
%define i [ebp + 16]
%define j [ebp + 20]

vector128: dd 128.0, 128.0, 128.0, 128.0

global sub_asm

section .text

sub_asm:

	push ebp
	mov ebp, esp
	push edi
	push esi
	push ebx

	;inicializacion variables
	mov edi, j						;EDI columna de la matriz
	mov eax, i_matrix				;EAX inicio de la fila donde hay que realizar el calculo
	xor edx, edx
	;calculo
	;HAY QUE USAR MOVDQU O OTRO MOV???????
	xorps xmm2, xmm2
	xorps xmm1, xmm1
	movdqu xmm2, [eax + edi * 4]	;XMM1 los 4 pixels que se calculan en esta iteración
	cvtdq2ps xmm1, xmm2				;pase lo que tengo en la matriz a punto flotante
	movdqu xmm2, [vector128]		;XMM2 [128.0,128.0,128.0,128.0]
	subps xmm1, xmm2				;XMM1 tenemos los pixels ya con la resta de 128

	movdqu xmm2, xmm1
	;dejo resultado en la matriz
	cvtps2dq xmm1, xmm2
	movdqu [eax + edi * 4], xmm1	;Dejamos el resultado en el lugar correspondiente en la matriz

	mov eax, edx					;devolvemos el valor de edx, el mismo debe ser 0 ya que se usa en la multiplicacion y tiene que alcanzar con 32 bits
	
	pop ebx
	pop esi
	pop edi
	pop ebp
	ret
