#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "test_huff.h"
//~ #include "functions.h"
#include "huffman.h"
#include <assert.h>

int ** armar_matriz_prueba(int w, int h)
{
	int **i_matrix;
    int i;
    i_matrix = (int**) malloc (h * sizeof (int*));    
    for (i = 0; i < h; i++)
        i_matrix[i] = (int*) malloc (w * sizeof (int)); 
	int j;
	for(i = 0; i < h; i++)
	{
		for(j = 0; j < w; j++)
		{
			i_matrix[i][j] = rand()%10+1;
//			printf("%i	", i_matrix[i][j]);
		}
	//	printf("\n");
	}
	//printf("\n");
	return i_matrix;
}

int test_compr_huff(int **i_matrix, int w, int h)
{
	//printf("test_comp_huff.... \n");
	int fila;
	int col;
	for(fila = 0; fila < w; fila = fila + 8)
	{
		for(col = 0; col < h; col = col + 8)
		{
			nodo_lista_ab * lista_ab;
		//	printf("generando tabla apariciones \n");
			lista_ab = generar_tabla_apariciones(i_matrix, w, h);
			mostrar_lista_ab(lista_ab);
			//printf("generando tabla de codigos \n");
			nodo_lista_c * lista_c;
			//~ codigo_t * tabla_codif[256];
			lista_c = generar_lista_codigos(lista_ab);
			//~ printf("mostrando lista \n");
			//~ mostrarListaAux(tabla_codigos);
			nodo_arbol_t * arbol;
			//printf("generando arbol huffman \n");
			arbol = generar_arbol_huffman(lista_ab);
			if (arbol!= 0)
			{
				//hubo un problema en generar arbol
			}
			//~ mostrarListaAux(tabla_codigos);
			//printf("mostrando arbol \n");
			mostrarArbolAux(arbol, 0);
			int * long_codificado;
			long_codificado = malloc(sizeof(int));
			*long_codificado = 0;
			//printf(" long_codificado = %i \n", *long_codificado);
			generar_codigos(lista_c, long_codificado);
			//printf(" long_codificado = %i \n", *long_codificado);
			//~ mostrar_codigos(lista_c);
			unsigned int * buffer;
			buffer = comprimir_buffer(i_matrix, 8, 8, lista_c, *long_codificado);
			int p;
			int m;
			m = (*long_codificado + (32-*long_codificado % 32))/32;
			//~ printf("longitud de codificacion mod 32 %i \n", *long_codificado % 32);
			//~ printf("longitud de codificacion redondeado a b %i \n", *long_codificado + (32-*long_codificado % 32));
			//~ printf("longitud de codificacion  %i ints\n", m);
			//printf("longitud de codificacion %i b\n", *long_codificado);
			//~ for(p = 0; p < m; p++)
			//~ {
				//~ printf("%X ", buffer[p]);
			//~ }
			//~ 
			int cant_codigos = long_lista_codigos(lista_c);
			mostrar_codigos(lista_c);
			nodo_arbol_t * arbol_desc = generar_arbol_descomprecion (lista_c, cant_codigos);
			mostrarArbolAux(arbol_desc, 0);
			descomprimir_buffer(*long_codificado, buffer, i_matrix, 8, 8, arbol);
			print_matrix(i_matrix, 8, 8);
		}
	}
//	printf("test_comp_huff... ok\n");
	return 0;
}



int test_compr_huff_im(int **i_matrix, int w, int h)		// int tam_header_bmp, FILE *  image_in,FILE * image_out)
{
	//printf("test_comp_huff.... \n");
	int fila;
	int col;
	//~ for(fila = 0; fila < w; fila = fila + 8)
	//~ {
		//~ for(col = 0; col < h; col = col + 8)
		//~ {
	//~ int tabla_ap[500];
	nodo_lista_ab * lista_ab;
	//printf("generando tabla apariciones \n");
	lista_ab = generar_tabla_apariciones(i_matrix, w, h);
	//~ mostrar_lista_ab(lista_ab);
	//printf("generando tabla de codigos \n");
	nodo_lista_c * lista_c;
	//~ codigo_t * tabla_codif[500];
	lista_c = generar_lista_codigos(lista_ab);
	//~ printf("mostrando lista \n");
	//~ mostrarListaAux(tabla_codigos);
	nodo_arbol_t * arbol;
	//printf("generando arbol huffman \n");
	arbol = generar_arbol_huffman(lista_ab);
	if (arbol!= 0)
	{
		//hubo un problema en generar arbol
	}
	//~ mostrarListaAux(tabla_codigos);
	//printf("mostrando arbol \n");
	//~ mostrarArbolAux(arbol, 0);
	int * long_codificado;
	long_codificado = malloc(sizeof(int));
	*long_codificado = 0;
	//printf(" long_codificado = %i \n", *long_codificado);
	generar_codigos(lista_c, long_codificado);
	//printf(" long_codificado = %i \n", *long_codificado);
	//~ mostrar_codigos(lista_c);
	unsigned int * buffer;
	buffer = comprimir_buffer(i_matrix, w, h, lista_c, *long_codificado);
	int p;
	int m;
	m = (*long_codificado + (32-*long_codificado % 32))/32;
	//~ write_buffer(buffer, m, image_out);
	//printf("longitud de codificacion mod 32 %i \n", *long_codificado % 32);
	//printf("longitud de codificacion redondeado a b %i \n", *long_codificado + (32-*long_codificado % 32));
	//printf("longitud de codificacion  %i ints\n", m);
	//printf("longitud de codificacion %i b\n", *long_codificado);
	//~ for(p = 0; p < m; p++)
	//~ {
		//~ printf("%X ", buffer[p]);
	//~ }
	
	//~ write_header(*long_codificado, tam_header_bmp, lista_c, image_in, image_out);
	
	int cant_codigos = long_lista_codigos(lista_c);
	//~ int indice = tam_header_bmp + TAM_HEADER_OC2 + cant_codigos * 12;
	//~ printf ("Indice donde se comienza a escribir el buffer con la imagen: %i\n", indice);
	//~ write_buffer(buffer, m, image_out, indice);
	
	int cant_hojas_elim = eliminar_arbol(arbol);
	//printf("Eliminada %i hojas del arbol\n", cant_hojas_elim);
	
	
	//~ print_matrix(i_matrix, w, h);
		//~ }
	//~ }
	//printf("test_comp_huff... ok\n");
	return 0;
}

int test_descompr_huff_im(int **i_matrix, int w, int h)
{
	FILE * compress_image;
	FILE * image_out;
	compress_image = fopen("lena_out.oc2", "rb+");
	image_out = fopen("lena_out.bmp", "wb+");
	
	oc2_header_t * oc2;
	oc2 = leer_info_oc2(compress_image);
	mostrar_oc2(oc2);
	
	nodo_lista_c * lista_c = NULL;
	//printf("Cantidad de codigos recuperados %i\n", long_lista_codigos(lista_c));

	lista_c = leer_codigos(compress_image, oc2->cant_codigos, oc2->offset_tabla);
	mostrar_codigos(lista_c);
	//printf("Cantidad de codigos recuperados %i\n", long_lista_codigos(lista_c));

	nodo_arbol_t * arbol_huff = generar_arbol_descomprecion (lista_c, oc2->cant_codigos);
	//~ mostrarArbolAux(arbol_huff, 0);

	//~ printf ("Generando matriz para el recupero de la imagen...	\n");
	//~ int **i_matrix_out;
    int i;
    //~ i_matrix_out = (int**) malloc (HIGH * sizeof (int*));    
    //~ for (i = 0; i < HIGH; i++)
        //~ i_matrix_out[i] = (int*) malloc (WIDTH * sizeof (int)); 
        //~ 
	//~ printf ("		OK \n");

	fseek (compress_image, oc2->offset_header, SEEK_SET);
	fseek(image_out, 0, SEEK_SET);
	unsigned int header_aux;

	//printf("Copiando header al archivo descomprimido...	\n");
	for (i = 0; i < oc2->tam_header; ++i)
	{
		header_aux = fgetc(compress_image);
		fputc(header_aux, image_out);
		//printf("%i ", header_aux);
	}
	//printf("\n");
	//printf ("		OK\n");


	fseek (compress_image, oc2->offset_codificacion, SEEK_SET);
	int tam_codif_bytes = (oc2->long_codificacion + (32-oc2->long_codificacion % 32))/8;
	//printf("tam_codif_bytes: %i \n", tam_codif_bytes);
	unsigned int * buffer = malloc(tam_codif_bytes);
	unsigned int * buffer_aux = buffer;
	//printf ("Copiando los datos comprimidos al buffer...	\n");
	for (i = 0; i < tam_codif_bytes; ++i)
	{
		fread(buffer_aux, sizeof(unsigned int), 1, compress_image);
		buffer_aux++;
	}
	//printf ("		OK\n");
	
	
	descomprimir_buffer(oc2->long_codificacion, buffer, i_matrix, w, h, arbol_huff);
	
	
	int size;
	//~ fseek(image_out, 2, SEEK_SET);
	//~ fread(&size, 4, 1, image_out);
	
	//~ fseek (image_out, oc2->tam_header, SEEK_SET);

	//~ write_buffer(header_bmp, oc2->tam_header, image_out, 0);
	//~ write_image(image_out, i_matrix, w, h, oc2->tam_header, size);

	fclose(compress_image);
	fclose(image_out);
	return 0;
}
