#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "test_jpeg.h"
#include "functions.h"
#include <assert.h>

void test_range128(int ** i_matrix, int width, int high)
{
	//printf("testing range of matrix \n");
	//~ print_matrix(i_matrix, width, high);
	int r, c;
	for(r = 0; r < 512; r++)
	{
		for(c = 0; c < 512; c++)
		{
			assert(i_matrix[r][c] > -129);
			assert(i_matrix[r][c] < 128);
		}
	}
}	

void test_range256(int ** i_matrix, int width, int high)
{
	//printf("testing range 256 of matrix \n");
	//~ print_matrix(i_matrix, width, high);
	int r, c;
	for(r = 0; r < high; r++)
	{
		for(c = 0; c < width; c++)
		{
			if(i_matrix[r][c] < 0 || i_matrix[r][c] > 255)
			{
				//~ printf("i_matrix[%i][%i]:	%i\n", r, c, i_matrix[r][c]);
				if (i_matrix[r][c] < 0) i_matrix[r][c] = 0;
				if (i_matrix[r][c] > 255) i_matrix[r][c] = 255;
			}
			assert(i_matrix[r][c] >= 0);
			assert(i_matrix[r][c] <= 256);
		}
	}
}	

void test_range500(int ** i_matrix, int width, int high)
{
	//printf("testing range 256 of matrix \n");
	//~ print_matrix(i_matrix, width, high);
	int r, c;
	for(r = 0; r < high; r++)
	{
		for(c = 0; c < width; c++)
		{
			//~ if(i_matrix[r][c] < 0 || i_matrix[r][c] > 500)
			//~ {
				//~ printf("i_matrix[%i][%i]:	%i\n", r, c, i_matrix[r][c]);
			//~ }
			assert(i_matrix[r][c] >= 0);
			assert(i_matrix[r][c] <= 500);
		}
	}
}	


int test_dct(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	divide_by_blocks_and_dct(i_matrix, width, high);
	//printf("\n matrix luego de dct \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128(i_matrix, width, high);
	return 0;
}


int test_quant(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	divide_by_blocks_and_quant(i_matrix, width, high);
	//printf("\n matrix luego de quant \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128(i_matrix, width, high);
	return 0;
}

int test_thresh(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	threshold (i_matrix, width, high, -900);
	//printf("\n matrix luego de thresh \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128(i_matrix, width, high);
	//~ test_range500(i_matrix, width, high);
	return 0;
}


int test_m_quant(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	divide_by_blocks_and_m_quant(i_matrix, width, high);
	//printf("\n matrix luego de m_quant \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128(i_matrix, width, high);
	return 0;
}

int test_idct(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	divide_by_blocks_and_idct(i_matrix, width, high);
	//printf("\n matrix luego de thresh \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128	(i_matrix, width, high);
	return 0;
}

int test_substract_128(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	substract_128(i_matrix, width, high);
	//printf("\n matrix luego de substract_128 \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range128	(i_matrix, width, high);
	return 0;
}

int test_add_128(int ** i_matrix, int width, int high)
{
	//~ print_matrix(i_matrix, width, high);
	add_128(i_matrix, width, high);
	//printf("\n matrix luego de add_128 \n");
	//~ print_matrix(i_matrix, width, high);
	//~ test_range256 (i_matrix, width, high);
	return 0;
}
/*
int test_reduce_image(int ** i_matrix, int WIDTH, int HIGH)
{
	reduce_image(i_matrix, WIDTH, HIGH);
	return 0;
}
*/
